/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataOpcComputeStorageVolumeSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/opc/1.4.1/docs/data-sources/compute_storage_volume_snapshot#id DataOpcComputeStorageVolumeSnapshot#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/hashicorp/opc/1.4.1/docs/data-sources/compute_storage_volume_snapshot#name DataOpcComputeStorageVolumeSnapshot#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/hashicorp/opc/1.4.1/docs/data-sources/compute_storage_volume_snapshot opc_compute_storage_volume_snapshot}
*/
export declare class DataOpcComputeStorageVolumeSnapshot extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "opc_compute_storage_volume_snapshot";
    /**
    * Generates CDKTF code for importing a DataOpcComputeStorageVolumeSnapshot resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataOpcComputeStorageVolumeSnapshot to import
    * @param importFromId The id of the existing DataOpcComputeStorageVolumeSnapshot that should be imported. Refer to the {@link https://registry.terraform.io/providers/hashicorp/opc/1.4.1/docs/data-sources/compute_storage_volume_snapshot#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataOpcComputeStorageVolumeSnapshot to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/hashicorp/opc/1.4.1/docs/data-sources/compute_storage_volume_snapshot opc_compute_storage_volume_snapshot} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataOpcComputeStorageVolumeSnapshotConfig
    */
    constructor(scope: Construct, id: string, config: DataOpcComputeStorageVolumeSnapshotConfig);
    get account(): string;
    get collocated(): cdktf.IResolvable;
    get description(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get machineImageName(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get parentVolumeBootable(): cdktf.IResolvable;
    get platform(): string;
    get property(): string;
    get size(): string;
    get snapshotId(): string;
    get snapshotTimestamp(): string;
    get startTimestamp(): string;
    get status(): string;
    get statusDetail(): string;
    get statusTimestamp(): string;
    get tags(): string[];
    get uri(): string;
    get volumeName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
